#pragma once
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#ifdef NO_GC
#include <gc.h>
#define malloc(n) GC_malloc(n)
#else
#include <stdlib.h>
#endif

#include "color.h"

void info(char* ustr, ...) {
	char* tstr = GRN "INFO: " CRESET;
	char* str = malloc(strlen(tstr) + strlen(ustr) + 1);
	sprintf(str, "%s%s", tstr, ustr);
	//strcat(str, ustr);
	
	va_list lst;
	va_start(lst, ustr);
	vprintf(str, lst);
}

void warn(char* ustr, ...) {
	char* tstr = YEL "WARN: " CRESET;
	char* str = malloc(strlen(tstr) + strlen(ustr) + 1);
	sprintf(str, "%s%s", tstr, ustr);
	
	va_list lst;
	va_start(lst, ustr);
	vprintf(str, lst);
}

void error(char* ustr, ...) {
	char* tstr = RED "ERR: " CRESET;
	char* str = malloc(strlen(tstr) + strlen(ustr) + 1);
	sprintf(str, "%s%s", tstr, ustr);
	
	va_list lst;
	va_start(lst, ustr);
	vprintf(str, lst);
}

void reqlog(char* ustr, ...) {
	char* tstr = WHT "REQ: " CRESET;
	char* str = malloc(strlen(tstr) + strlen(ustr) + 1);
	sprintf(str, "%s%s", tstr, ustr);
	
	va_list lst;
	va_start(lst, ustr);
	vprintf(str, lst);
}
